"""sous programme: Commande du servomoteur d’orientation de la tablette"""

import RPi.GPIO as GPIO								#importation de la librairie Rasberry
import time											#importation de la librairie time


angle=90											#affectation de l'angle milieu de positionnement de la tablette (90°)

def rapport_cyclique_en_pourcentage(angle) :		#fonction qui permet de calculer le rapport cyclique en % en fonction de l'angle
    if angle > 180 or angle < 0 :
        return False

    RC_0_degre=2.5									#rapport cyclique: impulsion pour 0° / temps pour un cycle= 0.5/20= 0.025=2.5% 
    RC_180_degre = 12.5								#rapport cyclique: impulsion pour 180° / temps pour un cycle= 2.5/20= 0.125=12.5%
    ratio = (RC_180_degre - RC_0_degre)/180 		#Calcul du ratio pour l'angle en pourcentage

    RC_en_pourcentage = angle * ratio

    return RC_0_degre + RC_en_pourcentage			#la fonction renvoie le nouveau rapport cyclique en %											

GPIO.setmode(GPIO.BOARD) 							#utilisation du mode de numérotation de la carte
GPIO.setwarnings(False) 							#désactivé les avertissements

#utilisation de la broche 12 pour commander en PWM le servomoteur
pwm_gpio = 12										#numéro du port de commande du servomoteur
frequence = 50										#fréquence 50Hz
GPIO.setup(pwm_gpio, GPIO.OUT)						#affectation de la broche 12 en sortie
pwm = GPIO.PWM(pwm_gpio, frequence)					#création d'une instance pwm 

#utilisation des broches 15 et 16 pour récupérer l'appui sur les boutons de l'application
GPIO.setup(15, GPIO.IN)								#broche 15 affecter en entrée 
GPIO.setup(16, GPIO.IN)								#broche 16 affecter en entrée 

pwm.start(rapport_cyclique_en_pourcentage(angle)) 	#positionnement de la tablette à 90°
while True: 										
	monter_tablette = GPIO.input(15)				# renommage de l'entrée 15:ici recevra l'information d'augmenter l'angle
	descendre_tablette = GPIO.input(16)				# renommage de l'entrée 16:ici recevra l'information de dimuninuer l'angle
	if (monter_tablette==True):
		pwm.ChangeDutyCycle(rapport_cyclique_en_pourcentage(angle))		#pwm.ChangeDutyCycle permet de changer le rapport du cycle qui est 
																		#le résulat de la fonction def rapport_cyclique_en_pourcentage(angle):
																		#RQ: Le temps d'execution de la commande pour 1° est de 20 ms (temps de la 
																		#période) donc 3.6s pour 180°.
		angle= angle + 1												#incrémentation de l'angle
		time.sleep (0.02)												#temps de pause en seconde par degré: 0.020s (donc 3.6s de pause pour 180°). 
	elif (descendre_tablette==True):
		pwm.ChangeDutyCycle(rapport_cyclique_en_pourcentage(angle))
		angle= angle - 1
		time.sleep (0.02)
	else:
		pwm.ChangeDutyCycle(rapport_cyclique_en_pourcentage(angle))		#garde le rapport cyclique pour la position actuelle de la tablette
		time.sleep (0.02)	

#fin de programme		
pwm.stop()
GPIO.cleanup()