"""sous programme: Commande du servomoteur d'orientation de la tablette avec PWM"""
import time                       #importation des librairie
from machine import Pin
from machine import Pin, PWM

led=Pin(16,Pin.OUT)              # affectation des broches en entrees sorties
mont=Pin(26,Pin.IN)
desc=Pin(17,Pin.IN)
angle=90	                #affectation de l'angle milieu de positionnement de la tablette (90°)
duty=120									

def rapport_cyclique_en_pourcentage(angle) :  #fonction qui permet de calculer le rapport cyclique en % en fonction de l'angle
    if angle > 180 or angle < 0 :
        return False

    RC_0_degre=2.5									#rapport cyclique: impulsion pour 0° / temps pour un cycle= 0.5/20= 0.025=2.5% 
    RC_180_degre = 12.5								#rapport cyclique: impulsion pour 180° / temps pour un cycle= 2.5/20= 0.125=12.5%
    ratio = (RC_180_degre - RC_0_degre)/180 		#Calcul du ratio pour l'angle en pourcentage
    RC_en_pourcentage = angle * ratio

    return RC_0_degre + RC_en_pourcentage			#la fonction renvoie le nouveau rapport cyclique en %	

while True:
  de=desc.value()  #lire l'etat du BP descente
  mo=mont.value()   #lire la valeur du BP montee
  if (mo == 1):
        led.value(0)       # eteindre la del si déplacement
        dutyservo=rapport_cyclique_en_pourcentage(angle)*10
        dutyservo=int(dutyservo)               # garder que la valeur entiere du rapport cyclique
        pwm1=PWM(Pin(25), freq=50,duty=dutyservo) # change le rapport cyclique et l'envoie au servomoteur
        angle= angle + 1												#incrementation de l'angle
        time.sleep (0.02)	   #temps de pause pour ralentir la vitesse mettre un # pour faire un test sans retard
        time.sleep (0.005)												#temps de pause : pour compenser les temps de reaction
  elif (de==1): 
        led.value(0)       # eteindre la del si déplacement
        dutyservo=rapport_cyclique_en_pourcentage(angle)*10
        dutyservo=int(dutyservo)
        pwm1=PWM(Pin(25), freq=50, duty=dutyservo)
        angle= angle - 1												
        time.sleep (0.02)
        time.sleep (0.005)												
      
  else: 
        
        led.value(1)       # allumage d'une del si aucun déplacement
        time.sleep (0.02)	
